class kryColorTable : public kryObject
{
public:
  kryColorTable(int n_colors);
  ~kryColorTable();

  kryColor *Get(int id);
  void Set(int id, char *t_id, char *name, int red, int green, int blue);

  void *GetUserData(int id);
  void SetUserData(int id, void *data);

  int GetRefCount();
  void Ref();
  void Unref();

  int GetColorCount();

  void EnableOpacity();


  enum
  {
    SIGNAL_COLOR_CHANGED,
    SIGNAL_COUNT
  };

private:
  gboolean CheckId(int id);
  static void kryColorChangedW(kryObject *obj, void *param, kryColorTable *color_table);

  /* array of colors */
  kryColor *m_colors;
  /* reference count of the object */
  int m_refcount;
  /* color count */
  int m_color_count;
};
