/* 
 *	Copyright (C) 2004-2005 Vadim Berezniker
 *	http://www.kryptolus.com
 *
 *  This Program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  This Program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *  http://www.gnu.org/copyleft/gpl.html
 *
 */

#include "stdafx.h"

#include "common.h"

kryError::kryError()
{
  this->m_msg = NULL;
}

kryError::kryError(kryError const& error)
{
  this->m_msg = g_strdup(error.m_msg);
}

kryError::kryError(char *msg, ...)
{
  va_list list;

  va_start(list, msg);
  this->m_msg = g_strdup_vprintf(msg, list);
  va_end(list);
}

kryError::~kryError()
{
  g_free(this->m_msg);
}

char *kryError::GetMessage()
{
  return this->m_msg;
}
