#ifndef _KRY_OBJECT_H
#define _KRY_OBJECT_H 1

class kryObject
{
public:
  kryObject(int nSignals);
  void operator =(kryObject & kryObject);
  ~kryObject();

  void DisableSignal(int id);
  void EnableSignal(int id);
  long ConnectSignal(int id, krySignalFunc0 func);
  long ConnectSignal(int id, krySignalFunc1 func, void *connect_data1);
  long ConnectSignal(int id, krySignalFunc2 func, void *connect_data1, void *connect_data2);
  void DisconnectSignal(int id, void *func);
  void DisconnectSignal(int id, int id_sig);
  void InvokeSignal(int id, void *param);
private:
  gboolean CheckId(int id);

  krySignal *m_signals;
  int m_n_signals;
};

#endif


