/* 
 *	Copyright (C) 2004-2005 Vadim Berezniker
 *	http://www.kryptolus.com
 *
 *  This Program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  This Program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *  http://www.gnu.org/copyleft/gpl.html
 *
 */

#include "stdafx.h"

#include "common.h"

kryPrefValue::kryPrefValue() : m_data(0), m_type(PREF_NONE)
{
}

kryPrefValue::~kryPrefValue()
{
}

void kryPrefValue::Free(kryPrefValue *value)
{
  if(value->m_type == PREF_STRING)
  {
    kry_free(value->m_data);
  }
  else if(value->m_type == PREF_LIST)
  {
    g_list_foreach((GList *) value->m_data, (GFunc) kryPrefValue::Free, NULL);
    g_list_free((GList *) value->m_data);
  }
}

void *kryPrefValue::GetData()
{
  return this->m_data;
}

void kryPrefValue::SetData(void *data)
{
  this->m_data = data;
}

enum kryPrefValue::pref_type kryPrefValue::GetType()
{
  return this->m_type;
}

void kryPrefValue::SetType(enum pref_type type)
{
  this->m_type = type;
}

