/* 
 *	Copyright (C) 2004-2005 Vadim Berezniker
 *	http://www.kryptolus.com
 *
 *  This Program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  This Program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *  http://www.gnu.org/copyleft/gpl.html
 *
 */
#include "stdafx.h"

#include "common.h"

#include "kryArray.h"
#include "kryString.h"
#include "krySSACommandParser.h"
#include "krySSACommandStripper.h"

krySSACommandStripper::krySSACommandStripper(kryString str) : m_length(0)
{
  ParseSubtitleString(str);
}

krySSACommandStripper::~krySSACommandStripper()
{
  this->m_strings.ForEach((GFunc) kry_free_minimal, NULL);
}

void krySSACommandStripper::OnString(kryString &str, int offset)
{
  this->m_strings.Add(kry_strdup(str.GetBuffer()));
  this->m_length += strlen(str.GetBuffer());
}

char *krySSACommandStripper::GetString()
{
  int offset = 0;
  char *full_str = (char *) kry_malloc(this->m_length + 1);
  full_str[this->m_length] = 0;

  kryListIterator<char *> iter;
  this->m_strings.GetIterator(&iter);
  while(char *str = iter.GetNext())
  {
    memcpy(full_str + offset, str, strlen(str));
    offset += strlen(str);
  }

  return full_str;
}



