#include <iconv.h>


struct style_iconv_map
{
  gboolean present;
  iconv_t iconv_h;
  char *src_encoding;
};

class krySubReader : public kryTextFileReader
{
public:
  krySubReader(char *filename);
  virtual ~krySubReader();

  enum retval
  {
    SCRIPT_OK, 
    SCRIPT_ERROR, 
    SCRIPT_WRONGFORMAT
  };

  virtual enum retval ReadScript(kryScript *script, kryList<kryTextParseError *> *list) = 0;

  void AddError(kryTextParseError *error);

protected:

  void AddEvent(kryEventDetailed *event);
  
  kryList<kryTextParseError *> *m_errors;
  kryHash<char *, struct style_iconv_map *> *m_style_iconv;
  kryScript *m_script;

};


