#ifndef __kry_region_H__
#define __kry_region_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define KRY_TYPE_REGION                  (kry_region_get_type ())
#define KRY_REGION(obj)                  (G_TYPE_CHECK_INSTANCE_CAST ((obj), KRY_TYPE_REGION, KryRegion))
#define KRY_REGION_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST ((klass), KRY_TYPE_REGION, KryRegionClass))
#define KRY_IS_REGION(obj)               (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KRY_TYPE_REGION))
#define KRY_IS_REGION_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE ((klass), KRY_TYPE_REGION))
#define KRY_REGION_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS ((obj), KRY_TYPE_REGION, KryRegionClass))


typedef struct _KryRegion	    KryRegion;
typedef struct _KryRegionClass  KryRegionClass;

struct _KryRegion
{
  GObject parent_instance;

  KryMarker *marker_start;
  KryMarker *marker_end;

  int color_id;
};

struct _KryRegionClass
{
  GObjectClass parent_class;
  
  void (* changed)	 (KryRegion *marker);
  void (* value_changed) (KryRegion *marker);
};


GType	   kry_region_get_type		(void) G_GNUC_CONST;
GObject* kry_region_new (KryMarker *marker_start, KryMarker *marker_end, int colorid);
void kry_region_changed		(KryRegion *region);
void kry_region_value_changed		(KryRegion *region, int old_val);

KryMarker *kry_region_get_marker_start(KryRegion *region);
KryMarker *kry_region_get_marker_end(KryRegion *region);
gboolean kry_region_is_highlighted(KryRegion *region);
int kry_region_get_colorid(KryRegion *region);
void kry_region_selected (KryRegion *region);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __kry_region_H__ */
